serenity/Kernel/build-image-qemu.sh
George Pickering 704f48d7f3 POSIX compliance: (most) shell scripts converted to generic shell
Ports/.port_include.sh, Toolchain/BuildIt.sh, Toolchain/UseIt.sh
have been left largely untouched due to use of Bash-exclusive
functions and variables such as $BASH_SOURCE, pushd and popd.
2019-11-03 09:26:22 +01:00

39 lines
825 B
Bash
Executable file

#!/bin/sh
set -e
die() {
echo "die: $*"
exit 1
}
if [ "$(id -u)" != 0 ]; then
die "this script needs to run as root"
fi
echo "setting up disk image..."
qemu-img create _disk_image "${DISK_SIZE:-500}"m || die "couldn't create disk image"
chown "$build_user":"$build_group" _disk_image || die "couldn't adjust permissions on disk image"
echo "done"
printf "creating new filesystem... "
mke2fs -q -I 128 _disk_image || die "couldn't create filesystem"
echo "done"
printf "mounting filesystem... "
mkdir -p mnt
mount _disk_image mnt/ || die "couldn't mount filesystem"
echo "done"
cleanup() {
if [ -d mnt ]; then
printf "unmounting filesystem... "
umount mnt || ( sleep 1 && sync && umount mnt )
rm -rf mnt
echo "done"
fi
}
trap cleanup EXIT
./build-root-filesystem.sh